import { strlen } from '../utils.ts';
import { getRuntime } from '../runtime.ts';

class Buffer {
	#b = '';

	constructor() {
	}

	append(s: string): void {
		this.#b += s;
	}

	appendLine(s: string): void {
		this.#b += s + '\r\n';
	}

	clear(): void {
		this.#b = '';
	}

	getBuffer(): string {
		return this.#b;
	}

	async flush() {
		const { io } = await getRuntime();
		await io.write(this.#b);
		this.clear();
	}

	strlen(): number {
		return strlen(this.#b);
	}
}

export default Buffer;
